SystemOrganization addCategory: #'Cutie-Helvetia-Ebnf'!

TestCase subclass: #CHEbnfTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Ebnf'!

!CHEbnfTest methodsFor: 'accessing' stamp: 'lr 9/23/2010 22:40'!
classes
	^ Array with: CH2EbnfNumberParser1 with: CH2EbnfNumberParser2 with: CH2EbnfNumberParser3! !

!CHEbnfTest methodsFor: 'testing' stamp: 'lr 12/2/2008 14:56'!
testCodeExecutes
	| result |
	self classes do: [ :each | 
		result := each parse: '-1.23'.
		self assert: (result = #($- ($1) ($. ($2 $3)))
			or: [ result = #($- $1 () ($. $2 ($3))) ]) ]! !

!CHEbnfTest methodsFor: 'testing' stamp: 'lr 9/23/2010 22:37'!
testSameMethods
	| reference method |
	reference := self classes first
		compiledMethodAt: #digit.
	self classes do: [ :each |
		method := each compiledMethodAt: #digit.
		self assert: (reference decompile printString 
			= method decompile printString) ]! !

CH2EbnfNumberParser subclass: #CH2EbnfNumberParser1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Ebnf'!

!CH2EbnfNumberParser1 methodsFor: 'grammar' stamp: 'lr 12/2/2008 12:15'!
digit 
    ^ $0 asParser / $1 asParser / $2 asParser / $3 asParser / $4 asParser / $5 asParser / $6 asParser / $7 asParser / $8 asParser / $9 asParser! !

!CH2EbnfNumberParser1 methodsFor: 'grammar' stamp: 'lr 7/2/2008 10:24'!
number 
    ^ $- asParser optional , self digit plus , ($. asParser , self digit plus) optional! !

CH2EbnfNumberParser subclass: #CH2EbnfNumberParser2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Ebnf'!

!CH2EbnfNumberParser2 class methodsFor: 'transform' stamp: 'lr 9/23/2010 22:11'!
transformLiterals
	<transform: 1>
    
	^ CHTreePattern new
		expression: '`#var' do: [ :context | 
			context node swapWith: (RBMessageNode 
				receiver: context node copy
				selector: #asParser) ];
		yourself! !

!CH2EbnfNumberParser2 class methodsFor: 'transform' stamp: 'lr 9/23/2010 22:11'!
transformReturn
	<transform: 3>
    
	^ [ :context |
		context node isMethod
			ifTrue: [ context node body addReturn ] ]! !

!CH2EbnfNumberParser2 class methodsFor: 'transform' stamp: 'lr 9/23/2010 22:11'!
transformVariables
	<transform: 2>
    
	^ CHTreePattern new
		expression: '`var' do: [ :context | 
			context node swapWith: (RBMessageNode 
				receiver: (RBVariableNode named: 'self') 
				selector: context node name asSymbol) ];
		yourself! !

!CH2EbnfNumberParser2 methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:11'!
digit 
	$0 / $1 / $2 / $3 / $4 / $5 / $6 / $7 / $8 / $9! !

!CH2EbnfNumberParser2 methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:12'!
number 
    $- optional , digit plus , ($. , digit plus) optional! !

CH2EbnfNumberParser subclass: #CH2EbnfNumberParser3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Ebnf'!

!CH2EbnfNumberParser3 class methodsFor: 'transform' stamp: 'lr 9/23/2010 22:39'!
ebnfHighlight
	<highlight>
	
	^ [ :context | 
		| tokens |
		tokens := CH1EbnfHighlighter
			parse: context text
			onError: [ :err | #() ].
		tokens flattenedDo: [ :each |
			each isVariableBinding ifTrue: [
				context
					scopeFrom: each key start 
					to: each key stop 
					with: nil visit: each value ] ] ]! !

!CH2EbnfNumberParser3 class methodsFor: 'transform' stamp: 'lr 9/23/2010 22:39'!
ebnfTransform
	<parse>
	
	^ [ :context | CH1EbnfParser parse: context stream ]! !

!CH2EbnfNumberParser3 class methodsFor: 'canceling' stamp: 'lr 6/16/2008 13:24'!
hightlightSmalltalk80
	^ nil! !

!CH2EbnfNumberParser3 methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:31'!
digit = "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" ;! !

!CH2EbnfNumberParser3 methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:31'!
number = [ "-" ] digit { digit } [ "." digit { digit } ] ;! !
